﻿
&НаСервере
&Вместо("РезультатЗапросаОстатковПоВыводуИзАссортимента")
Функция исперп_РезультатЗапросаОстатковПоВыводуИзАссортимента(ИмяТЧ)
	
	Результат	= Неопределено;
	
	Если НЕ исперп_Правка.Включена(исперп_Идентификатор
		.ОбработкаПомощникФормированияСкладскихДокументовПоВыводуИзАссортимента_Форма_РезультатЗапросаОстатковПоВыводуИзАссортимента()) Тогда
		Возврат ПродолжитьВызов(ИмяТЧ);
	КонецЕсли;
	
	Запрос=Новый Запрос();
	Тексты = Новый Массив();
	ТекстЗапроса =
		"ВЫБРАТЬ
		|	Склады.Склад КАК Склад,
		|	Склады.СкладПолучатель КАК СкладПолучатель
		|ПОМЕСТИТЬ Склады
		|ИЗ
		|	&Склады КАК Склады
		|;
		|
		|ВЫБРАТЬ РАЗРЕШЕННЫЕ
		|	ИзменениеАссортиментаТовары.Номенклатура КАК Номенклатура
		|ПОМЕСТИТЬ втТовары
		|ИЗ
		|	Документ.ИзменениеАссортимента.Товары КАК ИзменениеАссортиментаТовары
		|ГДЕ
		|	ИзменениеАссортиментаТовары.Ссылка = &ДокументОснование";
		
	// ::: +++ Добавлена забытая часть запроса
	Тексты.Добавить(ТекстЗапроса);
		
	Если исперп_Модуль.РаспределениеЗапасов().ЭтоПроизводительныйРежим() Тогда
		ТекстЗапроса =
			"ВЫБРАТЬ РАЗРЕШЕННЫЕ
			|	Запасы.Склад КАК Склад,
			|	Запасы.Номенклатура КАК Номенклатура,
			|	Запасы.Характеристика КАК Характеристика,
			|	Запасы.ВНаличииОстаток КАК Количество
			|ПОМЕСТИТЬ ТаблицаОстатков
			|ИЗ
			|	РегистрНакопления.ЗапасыИПотребности.Остатки(,
			|		Назначение = ЗНАЧЕНИЕ(Справочник.Назначения.ПустаяСсылка)
			|			И Номенклатура В(
			|				ВЫБРАТЬ
			|					втТовары.Номенклатура
			|				ИЗ
			|					втТовары)
			|			И Склад В(
			|				ВЫБРАТЬ
			|					Склады.Склад
			|				ИЗ
			|					Склады)) КАК Запасы
			|ИНДЕКСИРОВАТЬ ПО
			|	Склад";
	Иначе
		ТекстЗапроса =
			"ВЫБРАТЬ РАЗРЕШЕННЫЕ
			|	Остатки.Склад КАК Склад,
			|	Остатки.Номенклатура КАК Номенклатура,
			|	Остатки.Характеристика КАК Характеристика,
			|	СУММА(Остатки.ВНаличии) КАК Количество
			|ПОМЕСТИТЬ ТаблицаОстатков
			|ИЗ
			|	РегистрСведений.РаспределениеЗапасов КАК Остатки
			|ГДЕ
			|	Остатки.Состояние = ЗНАЧЕНИЕ(Перечисление.РаспределениеЗапасовСостояния.ОстатокНаСкладе)
			|		И Остатки.Назначение = ЗНАЧЕНИЕ(Справочник.Назначения.ПустаяСсылка)
			|		И Остатки.Номенклатура В
			|				(ВЫБРАТЬ
			|					втТовары.Номенклатура
			|				ИЗ
			|					втТовары)
			|		И Остатки.Склад В
			|				(ВЫБРАТЬ
			|					Склады.Склад
			|				ИЗ
			|					Склады)
			|СГРУППИРОВАТЬ ПО
			|	Остатки.Склад, Остатки.Номенклатура, Остатки.Характеристика
			|ИНДЕКСИРОВАТЬ ПО
			|	Склад";
	КонецЕсли;
	Тексты.Добавить(ТекстЗапроса);
	ТекстЗапроса =
		"ВЫБРАТЬ РАЗРЕШЕННЫЕ
		|	Остатки.Склад КАК Склад,
		|	Остатки.Склад.Подразделение КАК Подразделение,
		|	Склады.СкладПолучатель КАК СкладПолучатель,
		|	Остатки.Номенклатура КАК Номенклатура,
		|	Остатки.Характеристика КАК Характеристика,
		|	СУММА(Остатки.Количество) КАК Количество,
		|	СУММА(Остатки.Количество) КАК КоличествоУпаковок
		|ИЗ
		|	ТаблицаОстатков КАК Остатки
		|		ВНУТРЕННЕЕ СОЕДИНЕНИЕ Склады КАК Склады ПО Склады.Склад = Остатки.Склад
		|
		|СГРУППИРОВАТЬ ПО
		|	Остатки.Склад, Остатки.Номенклатура, Остатки.Характеристика, Склады.СкладПолучатель
		|
		|УПОРЯДОЧИТЬ ПО
		|	Остатки.Склад.Наименование, Остатки.Номенклатура.Наименование
		|ИТОГИ
		|	МАКСИМУМ(Склады.СкладПолучатель) КАК СкладПолучатель
		|ПО Склад";
	Тексты.Добавить(ТекстЗапроса);
	Запрос.Текст = СтрСоединить(Тексты, ОбщегоНазначения.РазделительПакетаЗапросов());
	Запрос.УстановитьПараметр("ДокументОснование",Объект.ДокументОснование);
	ТаблицаОбъекта = Объект[ИмяТЧ].Выгрузить(Новый Массив()); //ТаблицаЗначений
	ПустаяСсылка = Документы[Объект.ВидСоздаваемыхДокументов].ПустаяСсылка();
	Для Каждого Строка Из Объект[ИмяТЧ] Цикл
		
		Если Строка[Объект.ВидСоздаваемыхДокументов] = ПустаяСсылка
				Или ТипЗнч(Строка[Объект.ВидСоздаваемыхДокументов])
					<> Тип("ДокументСсылка." + Объект.ВидСоздаваемыхДокументов) Тогда
			ЗаполнитьЗначенияСвойств(ТаблицаОбъекта.Добавить(), Строка);
		КонецЕсли;
		
	КонецЦикла;
	
	Запрос.УстановитьПараметр("Склады", ТаблицаОбъекта);
	Запрос.УстановитьПараметр("Дата", ТекущаяДатаСеанса());
	РезультатЗапроса = Запрос.Выполнить();
	Возврат РезультатЗапроса;
	
КонецФункции

